module Stack where

open import Coinduction
open import Data.Maybe
open import Data.List

record Stack (A : Set) : Set where
  constructor stack
  field
    top  : Maybe A
    pop  : ∞ (Stack A)
    push : A -> ∞ (Stack A)

head : {A : Set} -> List A -> Maybe A
head [] = nothing
head (a ∷ as) = just a

tail : {A : Set} -> List A -> List A
tail [] = []
tail (a ∷ as) = as

listToStack : {A : Set} -> List A -> Stack A
listToStack l = record
  { top  = head l
  ; pop  = ♯ listToStack (tail l)
  ; push = λ a → ♯ listToStack (a ∷ l)
  }
