module RBTreeEq (Key : Set) where

open import Data.Unit
open import Data.Nat
open import Relation.Binary.PropositionalEquality

data Color : Set where red black : Color

data RBTree (c : Color)(n : ℕ) : Set where
  leaf      : c ≡ black → n ≡ zero → RBTree c n
  redNode   : c ≡ red → RBTree black n → Key → RBTree black n → RBTree c n
  blackNode : c ≡ black → (m : ℕ) → n ≡ suc m → (c' : Color) →
                RBTree c' m → Key → RBTree c' m → RBTree c n